function init()
	RegisterTool("railgun", "Rail gun", "MOD/vox/railgun.vox")
	SetBool("game.tool.railgun.enabled", true)

	SetFloat("game.tool.railgun.ammo", 10)

	sound = LoadSound("MOD/snd/main2.ogg")
	sound2 = LoadSound("MOD/snd/end.ogg")

	delay = 60
	recoil = 0
	recoilAmount = 20
	charging = false
end

function tick(dt)
	if  GetString("game.player.tool") == "railgun" then
		if InputPressed("lmb") and GetFloat("game.tool.railgun.ammo") > 0 and not charging then
			if GetBool("savegame.mod.railgun_reload") then
				SetValue("delay",0,"linear",0)
				PlaySound(sound2)
			else
				SetValue("delay",0,"linear",4)
				PlaySound(sound)
			end
			charging = true
		end

		if delay <= 0 then
			railgunMain()
			delay = 1
			SetValue("delay",60,"linear",0.2)
			SetValue("recoil",recoilAmount,"easeout",0.1)
			charging = false
		end
		if recoil == recoilAmount then
			SetValue("recoil",0,"easein",0.5)
		end
		glow(5)
		animateRecoil()
	end

	if  GetString("game.player.tool") ~= "railgun" then
		delay = 1
		charging = false
	end
end

function hole(direction,position,depth,distance,size)
	for i = 2, depth do
		direction = VecNormalize(direction)
		local scaledDirection = VecScale(direction,i*distance)
		local holepos = VecAdd(position, scaledDirection)
		MakeHole(holepos,size,size,size)
		SpawnParticle("smoke", holepos, Vec(0,0,0), 1, 1.5)
		SpawnParticle("fire", holepos, Vec(0,0,0), 0.5, 0.8)
	end
end

function raycasthole(direction,position,size,explosionAmount)
	for i = 1, explosionAmount do
		local hit, dist, normal, shape = QueryRaycast(position, direction, 500)
		if hit then
			hitPos = VecAdd(VecScale(direction,dist),position)
			Explosion(hitPos,size)
		end
		position = VecAdd(hitPos,VecNormalize(direction))
		if VecLength(VecSub(GetPlayerTransform().pos,hitPos)) > 500 then
			break
		end
	end
end

function ReduceAmmo()
	local currentAmmo = GetFloat("game.tool.railgun.ammo")
	SetFloat("game.tool.railgun.ammo", currentAmmo-1)
end

function railgunMain()
	local t = GetCameraTransform()
	local cameraPoint = Vec(0,0,-1)
	local p = TransformToParentPoint(t, cameraPoint)
	direction = VecSub(p,t.pos)

	hole(direction,t.pos,400,0.8,1.5)
	--new method
	--raycasthole(direction,t.pos,1,30)
	ReduceAmmo()
end

function glow(amount)
	local b = GetToolBody()
	local shapes = GetBodyShapes(b)

	for i = 1, #shapes do
		SetShapeEmissiveScale(shapes[i],(60-delay)/amount)
	end
end

function animateRecoil()
	local t = Transform()
	t.pos = Vec(0,0,recoil/50)
	SetToolTransform(t)
end

